package aexp.phoneintent;

import android.app.Activity;
import android.database.Cursor;
import android.os.Bundle;
import android.widget.Button;
import android.util.Log;
import android.provider.CallLog;
import android.provider.BaseColumns;
import android.net.ContentURI;
import android.widget.TextView;
import android.view.View;

public class PhoneIntent extends Activity {
    private static final String LOG_TAG = "PhoneIntent";

    /** Called with the activity is first created. */
    @Override
    public void onCreate(Bundle icicle)
    {
        super.onCreate(icicle);
        setContentView(R.layout.main);
        Button dumpCallLogButton = (Button) findViewById( R.id.dump_log );
        dumpCallLogButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
			  String result = dumpCallLog();
			  TextView t = (TextView)findViewById(R.id.dump_log_result );
			  t.setText( result );
     		}
        });
    }

	private String dumpCallLog() {
	  String result = "Call log empty";
	  String[] projection = new String[] {
    	BaseColumns._ID,
    	CallLog.Calls.NUMBER,
		CallLog.Calls.TYPE
	  };
      Cursor managedCursor = managedQuery( 
					CallLog.Calls.CONTENT_URI,
                    projection, 
                    null,
                    CallLog.Calls.DEFAULT_SORT_ORDER );
      int numberColumn = managedCursor.getColumnIndex( CallLog.Calls.NUMBER ); 
      int typeColumn = managedCursor.getColumnIndex( CallLog.Calls.TYPE );
	  while ( managedCursor.next() ) {
		String number = managedCursor.getString( numberColumn );
        String type = managedCursor.getString( typeColumn );
		String dir = null;
		try {
		  int dircode = Integer.parseInt( type );
		  switch( dircode ) {
			case CallLog.Calls.OUTGOING_TYPE:
				dir = "OUTGOING";
				break;

			case CallLog.Calls.INCOMING_TYPE:
				dir = "INCOMING";
				break;

			case CallLog.Calls.MISSED_TYPE:
				dir = "MISSED";
				break;
		  }
		} catch( NumberFormatException ex ) {}
		if( dir == null )
			dir = "Unknown, code: "+type;
		result = dir+","+number;
		Log.d( LOG_TAG, "Number: "+number+" Type: "+dir );
	  }
	  managedCursor.close();
	  return result;
    }

}
